var requestNumberID = 0;

if (window.getPOSTHANDLER == undefined) {
  const POSTMESSAGE = window.postMessage;
  window.getPOSTHANDLER = function () {
    return POSTMESSAGE;
  };
}
window.addEventListener(
  "message",
  function (event) {
    if (event.source != window) return;
    if (event.data.TYPE && event.data.TYPE == "PAGE_RESPONSE") {
      eventPop(event);
    }
  },
  false
);

function eventPop(event) {
  if (event.data.REQUESET_ID != undefined && event.data.RESULT.data.config.ACTION == "NET") {
    if (CALLBACKTYPE[event.data.REQUESET_ID] != undefined) {
      if (event.data.RESULT.isOk) {
        CALLBACKTYPE[event.data.REQUESET_ID].success(event.data.RESULT.data);
      } else {
        CALLBACKTYPE[event.data.REQUESET_ID].error(event.data.RESULT.data);
      }
    }
  }
}

function createRequestId() {
  requestNumberID++;
  return "THNetID_" + requestNumberID;
}

var CALLBACKTYPE = {};

function Net(config) {
  return new Promise((r, j) => {
    var requestID = createRequestId();
    CALLBACKTYPE[requestID] = {
      success: r,
      error: j,
    };
    window.getPOSTHANDLER()({
      TYPE: "PAGE_REQUEST",
      REQUESET_ID: requestID,
      TEXTDATA: config,
      ACTION: "NET",
    });
  });
}

export default Net;
