function NetAdapter(sn) {
    var token = undefined;
    var msn = sn;
    this.getUser = getUser;
    this.getToken = getToken;
    this.czs = czs;
    this.getData = getData;
    var pt = "t_activity";
    var hdcanShow = "t_activity_can_show";
    this.setActivityPt = setActivityPt;
    this.setToken = setToken;
    this.activity = activity;
    this.canshow = canshow;
    this.exitQyAccount = exitQyAccount;
    this.noverShow = noverShow;
    this.getCateId = getCateId;
    this.require = require;
    this.requestBean = requireBase;
    this.getFile = getFile;
    this.getCrossDomainData = getCrossDomainData;
    this.getCrossResponeUrl = getCrossResponeUrl;



    /**
     * 
     * @param {sn:"dgjdService",
            an:"token",
            data:{},
            token:""} requestBean 
     */
    function post(requestBean) {
        return new Promise(function (resole, reject) {
            dgdsGetData(requestBean, function (data) {
                if (data.code == 0) {
                    resole(data);
                } else {
                    reject(data);
                }
            })
        })
    }
    /**
     * 获取用户
     * @param {} data 
     */
    function getUser(data) {
        var requestBean =
        {
            sn: msn,
            an: "user",
            data: JSON.stringify(data),
            token: token
        }
        return post(requestBean);

    }

    function setToken(t) {
        token = t;
    }

    function setActivityPt(p) {
        pt = p;
        hdcanShow = p + "_can_show";
    }

    function getToken(data) {
        var requestBean =
        {
            sn: msn,
            an: "token",
            data: JSON.stringify(data),
            token: token
        }
        return post(requestBean);
    }

    function activity(data) {
        var requestBean =
        {
            sn: "activity",
            an: pt,
            data: JSON.stringify(data),
            token: token
        }
        return post(requestBean);
    }

    function exitQyAccount() {
        var requestBean =
        {
            sn: "exitQyAccount",
            an: pt,
            data: "{}",
            token: token
        }
        return post(requestBean);
    }

    function canshow() {
        var requestBean = {
            sn: "activity",
            an: hdcanShow,
            data: JSON.stringify({}),
            token: token
        }
        return post(requestBean);
    }

    function noverShow() {
        var requestBean = {
            sn: "activity",
            an: "j_activity_novershow",
            data: JSON.stringify({}),
            token: token
        }
        return post(requestBean);
    }

    function czs(data, at) {
        var requestBean =
        {
            sn: msn,
            an: "czs",
            data: JSON.stringify(data),
            token: token,
            at: at,
        }
        return post(requestBean);

    }
    function require(data, routerMethod) {
        return requireBase(msn, routerMethod, data);
    }

    function requireBase(sn, routerMethod, data) {
        var requestBean =
        {
            sn: sn,
            router: true,
            rn: routerMethod,
            data: JSON.stringify(data),
            token: token
        }
        return post(requestBean);
    }

    function getData(data) {
        var requestBean =
        {
            sn: "dgjdService",
            an: "getdata",
            data: JSON.stringify(data),
            token: token
        }
        return post(requestBean);

    }

    function getCateId(data) {
        var requestBean =
        {
            sn: "dgjdService",
            an: "getCateId",
            data: JSON.stringify(data),
            token: token
        }
        return post(requestBean);
    }

    function dgdsGetData(data, func) {
        if (token == undefined) {
            data.url = commonUrl;
        } else {
            data.url = commonUrlWithUser;
        }
        DG_PostMessage('post', data, function (data) {
            // debugger
            if (token == undefined && data != undefined && data.data != undefined && data.data.token != undefined) {
                token = data.data.token;
            }
            func(data);
        });
    }

    function getFile(url) {
        return new Promise((r, j) => {
            dgdsGetBinary(url, r, j)
        })
    }

    function getCrossDomainData(url, encode) {
        return new Promise((r, j) => {
            dgdsGetBinary(url, function (data) {
                var reader = new FileReader();
                reader.onload = function (event) {
                    var content = reader.result;//内容就在这里
                    r(content);
                };
                if (encode != undefined) {
                    reader.readAsText(data, encode);
                } else {
                    reader.readAsText(data)
                }
            }, j);
        })
    }
    function getCrossDomainDataWithHead(url, encode, header) {
        return new Promise((r, j) => {
            dgdsGetBinary(url, function (data) {
                var reader = new FileReader();
                reader.onload = function (event) {
                    var content = reader.result;//内容就在这里
                    r(content);
                };
                if (encode != undefined) {
                    reader.readAsText(data, encode);
                } else {
                    reader.readAsText(data)
                }
            }, j, header);
        })
    }

    function getCrossResponeUrl(url) {
        return new Promise((r, j) => {
            dgdsGetResponUrl(url, function (data) {
                if (data.code == 0) {
                    r(data.url);
                } else {
                    j(data);
                }
            }, j);
        })
    }
    function dgdsGetResponUrl(url, func, j) {
        var data = {};
        data.url = url;
        DG_PostMessage("getData", data, function (result) {
            if (result.code == 0) {
                func({ code: 0, url: result.response });
            } else {
                j({ code: -1 });
            }
        })
    }

    function dgdsGetBinary(url, func, j, header) {
        var data = {};
        data.url = url;
        if (header != undefined) {
            data.header = header;
        }
        DG_PostMessage("getData", data, function (result) {
            if (result.code == 0) {
                func(dataURLtoBlob(result.data));
            } else {
                j({ code: -1 });
            }
        })
    }

    function dataURLtoBlob(dataurl) {
        var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
            bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
        while (n--) {
            u8arr[n] = bstr.charCodeAt(n);
        }
        return new Blob([u8arr], { type: mime });
    }

}

var newAdaterGenerate = (function newAdaterGenerate() {
    var instance;
    return function (sn) {
        if (!instance) {
            instance = new NetAdapter(sn);
        }
        return instance;
    }
})()
export default newAdaterGenerate;